Index: code/trunk/src/network/CMakeLists.txt
===================================================================
--- code/trunk/src/network/CMakeLists.txt	(revision 1639)
+++ code/trunk/src/network/CMakeLists.txt	(revision 1735)
@@ -4,11 +4,18 @@
   ClientInformation.cc
   ConnectionManager.cc
-  GameStateManager.cc
-  GameStateClient.cc
+  GamestateManager.cc
+  GamestateClient.cc
+  GamestateHandler.cc
   PacketBuffer.cc
-  PacketDecoder.cc
-  PacketGenerator.cc
   Server.cc
   Synchronisable.cc
+  Host.cc
+  packet/Packet.cc
+  packet/Chat.cc
+  packet/ClassID.cc
+  packet/Acknowledgement.cc
+  packet/Gamestate.cc
+  packet/Welcome.cc
+  Host.cc
 )
 
@@ -31,18 +38,6 @@
   ##### test for gamestate stuff #####
   SET( TEST_SRC_FILES
-    ConnectionManager.cc
-    GameStateManager.cc
-    PacketBuffer.cc
-    PacketDecoder.cc
-    PacketGenerator.cc
-    ClientConnection.cc
-    ClientInformation.cc
-    diffTest.cc
-    GameStateClient.cc
-    Server.cc
-    Client.cc  
-    Synchronisable.cc  
+    ${NETWORK_SRC_FILES}
   )
-
   ADD_EXECUTABLE(networktest ${TEST_SRC_FILES})
   TARGET_LINK_LIBRARIES( networktest
@@ -55,128 +50,2 @@
   ##### end test for gamestate stuff #####
 ENDIF(NETWORK_TESTING_ENABLED)
-# build this if you want dummyserver4 and dummyclient4
-IF(NETWORKTRAFFIC_TESTING_ENABLED)
-  ##### test network traffic #####
-  SET( DUMMYSERVER4_SRC_FILES
-    ConnectionManager.cc
-    GameStateManager.cc
-    PacketBuffer.cc
-    PacketDecoder.cc
-    PacketGenerator.cc
-    ClientConnection.cc
-    ClientInformation.cc
-    GameStateClient.cc
-    Server.cc
-    Client.cc  
-    Synchronisable.cc
-    dummyserver4.cc
-  )
-
-  SET( DUMMYCLIENT4_SRC_FILES
-    ConnectionManager.cc
-    GameStateManager.cc
-    PacketBuffer.cc
-    PacketDecoder.cc
-    PacketGenerator.cc
-    ClientConnection.cc
-    ClientInformation.cc
-    GameStateClient.cc
-    Server.cc
-    Client.cc  
-    Synchronisable.cc
-    dummyclient4.cc
-  )
-
-  ADD_EXECUTABLE(dummyserver4 ${DUMMYSERVER4_SRC_FILES})
-  TARGET_LINK_LIBRARIES( dummyserver4
-    network
-    ${ENet_LIBRARY}
-    ${ZLIB_LIBRARY}
-    ${WINDOWS_ENET_DEPENDENCIES}
-    ${Boost_thread_LIBRARIES}
-    core
-    orxonoxs
-    audio
-  )
-
-  ADD_EXECUTABLE(dummyclient4 ${DUMMYCLIENT4_SRC_FILES})
-  TARGET_LINK_LIBRARIES( dummyclient4
-    network
-    ${ENet_LIBRARY}
-    ${ZLIB_LIBRARY}
-    ${WINDOWS_ENET_DEPENDENCIES}
-    ${Boost_thread_LIBRARIES}
-    core
-    orxonoxs
-    audio
-  )
-ENDIF(NETWORKTRAFFIC_TESTING_ENABLED)
-
-IF(BLABLA)
-  SET( CHATCLIENT_SRC_FILES
-    ClientConnection.cc
-    Client.cc
-    PacketBuffer.cc
-    PacketDecoder.cc
-    PacketGenerator.cc
-    dummyclient3.cc
-  )
-
-  SET( CHATSERVER_SRC_FILES
-    ConnectionManager.cc
-    GameStateManager.cc
-    PacketBuffer.cc
-    PacketDecoder.cc
-    PacketGenerator.cc
-    dummyserver3.cc
-  )
-
-  # chatserver for testing purposes
-  ADD_EXECUTABLE(chatserver ${CHATSERVER_SRC_FILES})
-  TARGET_LINK_LIBRARIES( chatserver
-    ${OGRE_LIBRARIES}
-    network
-    core
-    #objects
-    ${ENet_LIBRARY}
-    ${ZLIB_LIBRARY}
-    ${WINDOWS_ENET_DEPENDENCIES}
-  )
-
-  # chatclient for testing purpose
-  ADD_EXECUTABLE(chatclient ${CHATCLIENT_SRC_FILES})
-  TARGET_LINK_LIBRARIES( chatclient
-    ${OGRE_LIBRARIES}
-    network
-    core
-    #objects
-    ${ENet_LIBRARY}
-    ${ZLIB_LIBRARY}
-    ${WINDOWS_ENET_DEPENDENCIES}
-  )
-
-  # client for testing purpose
-  ADD_EXECUTABLE(client dummyclient2.cc)
-  TARGET_LINK_LIBRARIES( client
-    ${OGRE_LIBRARIES}
-    network
-    core
-    #objects
-    ${ENet_LIBRARY}
-    ${ZLIB_LIBRARY}
-    ${WINDOWS_ENET_DEPENDENCIES}
-  )
-
-  # server for testing purpose
-  ADD_EXECUTABLE(server dummyserver.cc)
-  TARGET_LINK_LIBRARIES( server
-    ${OGRE_LIBRARIES}
-    network
-    core
-    #objects
-    ${ENet_LIBRARY}
-    ${ZLIB_LIBRARY}
-    ${WINDOWS_ENET_DEPENDENCIES}
-  )
-ENDIF(BLABLA)
-
Index: code/trunk/src/network/Client.cc
===================================================================
--- code/trunk/src/network/Client.cc	(revision 1639)
+++ code/trunk/src/network/Client.cc	(revision 1735)
@@ -40,44 +40,15 @@
 
 #include "Client.h"
+#include "Host.h"
 #include "Synchronisable.h"
 #include "core/CoreIncludes.h"
 #include "core/ConsoleCommand.h"
-#include "Server.h"
+#include "packet/Packet.h"
+#include "packet/Acknowledgement.h"
 
 namespace network
 {
-  SetConsoleCommandShortcut(Client, Chat);
+//   SetConsoleCommandShortcut(Client, chat);
   
-  Client* Client::_sClient = 0;
-  
-  Client* Client::createSingleton(){
-    if(!_sClient){
-      _sClient = new Client();
-    }
-    return _sClient;
-  }
-  
-  Client* Client::createSingleton(std::string address, int port){
-    if(!_sClient)
-      _sClient = new Client(address, port);
-    return _sClient;
-  }
-  
-  Client* Client::createSingleton(const char *address, int port){
-    if(!_sClient)
-      _sClient = new Client(address, port);
-    return _sClient;
-  }
-  
-  void Client::destroySingleton(){
-    if(_sClient){
-      delete _sClient;
-      _sClient = 0;
-    }
-  }
-  
-  Client* Client::getSingleton(){
-    return _sClient; 
-  }
   
   /**
@@ -144,14 +115,17 @@
   }
 
+  bool Client::queuePacket(ENetPacket *packet, int clientID){
+    return client_connection.addPacket(packet);
+  }
   
-
-  void Client::Chat( std::string message ){
-    if(Client::getSingleton())
-      Client::getSingleton()->sendChat(message);
-    else if(Server::getSingleton())
-      Server::getSingleton()->sendChat(message);
-    else
-      COUT(1) << "do you want to monologize ??" << std::endl;
+  bool Client::processChat(packet::Chat *message, unsigned int clientID){
+    return message->process();
   }
+  
+  /*bool Client::sendChat(packet::Chat *chat){
+    chat->process();
+    packet::Packet *p = new packet::Packet(chat);
+    return p->send();
+  }*/
   
 
@@ -165,8 +139,7 @@
     if(!isConnected)
       return false;
-    return client_connection.addPacket(pck_gen.chatMessage( message.c_str() ));
-      //return client_connection.sendPackets();
+    packet::Chat chat(message, 0);
+    return chat.send();
     // send packets
-    return false;
   }
 
@@ -178,14 +151,11 @@
     if(client_connection.isConnected() && isSynched_){
       COUT(4) << "popping partial gamestate: " << std::endl;
-      GameStateCompressed *gs = gamestate.popPartialGameState();
+      /*packet::Gamestate *gs = gamestate.getGamestate();
       if(gs){
         COUT(4) << "client tick: sending gs " << gs << std::endl;
-        ENetPacket *packet = pck_gen.gstate(gs);
-        if( packet == NULL || !client_connection.addPacket(packet))
+        if( !gs->send() )
           COUT(3) << "Problem adding partial gamestate to queue" << std::endl;
-        // now delete it to save memory
-        delete[] gs->data;
-        delete gs;
-      }
+        // gs gets automatically deleted by enet callback
+      }*/
     }
     ENetEvent *event;
@@ -194,10 +164,12 @@
       event = client_connection.getEvent();
       COUT(5) << "tick packet size " << event->packet->dataLength << std::endl;
-      elaborate(event->packet, 0); // ================= i guess we got to change this .... (client_ID is always same = server)
+      packet::Packet *packet = packet::Packet::createPacket(event->packet, event->peer);
+      assert(packet->process());
     }
-    int gameStateID = gamestate.processGameState();
-    if(gameStateID==GAMESTATEID_INITIAL)
+    int gameStateID = gamestate.processGamestates();
+    /*if(gameStateID==GAMESTATEID_INITIAL)
       if(gameStateFailure_){
-        if(!client_connection.addPacket(pck_gen.acknowledgement(GAMESTATEID_INITIAL)))
+        packet::Acknowledgement ack(GAMESTATEID_INITIAL, 0);
+        if(!ack.send())
           COUT(3) << "could not (negatively) ack gamestate" << std::endl;
         else 
@@ -211,42 +183,11 @@
         isSynched_=true;
       gameStateFailure_=false;
-      if(!client_connection.addPacket(pck_gen.acknowledgement(gameStateID)))
+      packet::Acknowledgement ack(gameStateID, 0);
+      if(!ack.send())
         COUT(3) << "could not ack gamestate" << std::endl;
-    }// otherwise we had no gamestate to load
+    }*/// otherwise we had no gamestate to load
     gamestate.cleanup();
-    /*if(!client_connection.sendPackets())
-      COUT(3) << "Problem sending packets to server" << std::endl;*/
     return;
   }
 
-  void Client::processGamestate( GameStateCompressed *data, int clientID){
-    COUT(5) << "received gamestate id: " << data->id << std::endl;
-    gamestate.addGameState(data);
-  }
-
-  void Client::processClassid(classid *clid){
-    orxonox::Identifier *id;
-    id=ID(std::string(clid->message));
-    if(id!=NULL)
-      id->setNetworkID(clid->clid);
-    COUT(4) << "Client: received and set network id: " << clid->clid << "; classname: " << clid->message << std::endl;
-    COUT(4) << "id(classid)->getName " << ID((unsigned int)clid->clid)->getName() << std::endl;
-    delete clid;
-    return;
-  }
-
-  void Client::processChat( chat *data, int clientId){
-    COUT(1) << data->message << std::endl;
-    delete[] data->message;
-    delete data;
-  }
-  
-  bool Client::processWelcome( welcome *w ){
-    COUT(4) << "processing welcome message" << std::endl;
-    clientID_ = w->clientID;
-    shipID_ = w->shipID;
-    delete w;
-    return true;
-  }
-
 }
Index: code/trunk/src/network/Client.h
===================================================================
--- code/trunk/src/network/Client.h	(revision 1639)
+++ code/trunk/src/network/Client.h	(revision 1735)
@@ -46,7 +46,8 @@
 #include <string>
 
+#include "Host.h"
+#include "packet/Chat.h"
 #include "ClientConnection.h"
-#include "PacketManager.h"
-#include "GameStateClient.h"
+#include "GamestateClient.h"
 //#include "NetworkFrameListener.h"
 
@@ -62,24 +63,6 @@
   *
   */
-  class _NetworkExport Client : PacketDecoder{
+  class _NetworkExport Client : public Host{
   public:
-    
-    static Client* createSingleton();
-    static Client* createSingleton(std::string address, int port);
-    static Client* createSingleton(const char *address, int port);
-    static void destroySingleton();
-    static Client *getSingleton();
-    
-    bool establishConnection();
-    bool closeConnection();
-
-    static void Chat( std::string message );
-    
-    int getShipID(){return shipID_;}
-    int getClientID(){return clientID_;}
-
-    void tick(float time);
-
-  private:
     Client();
     Client(std::string address, int port);
@@ -87,9 +70,23 @@
     ~Client();
     
-    static Client* _sClient;
+    bool establishConnection();
+    bool closeConnection();
+    bool queuePacket(ENetPacket *packet, int clientID);
+    bool processChat(packet::Chat *message, unsigned int clientID);
+    //bool sendChat(packet::Chat *chat);
+    
+//    static void Chat( std::string message );
+    
+    unsigned int shipID(){return shipID_;}
+    int playerID(){return clientID_;}
+    //static void setShipID( unsigned int shipID){ dynamic_cast<Client *>(instance_)->shipID_=shipID; }
+    static void setClientID( unsigned int clientID){ dynamic_cast<Client *>(instance_)->clientID_=clientID; }
+    
+    void tick(float time);
+
+  private:
     
     ClientConnection client_connection;
-    PacketGenerator pck_gen;
-    GameStateClient gamestate;
+    GamestateClient gamestate;
     bool isConnected;
     bool isSynched_;
@@ -98,8 +95,5 @@
     
     // implement data processing functions of PacketDecoder
-    void processGamestate( GameStateCompressed *data, int clientID);
-    void processClassid(classid *clid);
-    void processChat( chat *data, int clientId );
-    bool processWelcome( welcome *w );
+//     void processChat( chat *data, int clientId );
     int clientID_;     // this is the id the server gave to us
     int shipID_;
Index: code/trunk/src/network/ClientInformation.cc
===================================================================
--- code/trunk/src/network/ClientInformation.cc	(revision 1639)
+++ code/trunk/src/network/ClientInformation.cc	(revision 1735)
@@ -46,41 +46,19 @@
 {
   
+  ClientInformation *ClientInformation::head_=0;
+  
   ClientInformation::ClientInformation() {
+    if(!head_)
+      head_=this;
     gamestateID_=GAMESTATEID_INITIAL;
     preve=0;
     nexte=0;
     partialGamestateID_=GAMESTATEID_INITIAL-1;
-    this->head_=false;
     synched_=false;
   }
 
-  ClientInformation::ClientInformation(bool head) {
-    gamestateID_=GAMESTATEID_INITIAL;
-    preve=0;
-    nexte=0;
-    partialGamestateID_=GAMESTATEID_INITIAL-1;
-    this->head_=head;
-    synched_=false;
-  }
-
-  // ClientInformation::ClientInformation(ClientInformation *prev) {
-  //   if(prev->next()!=0){
-  //     this->nexte=prev->next();
-  //     this->nexte->setPrev(this);
-  //   }
-  //   else
-  //     this->nexte = 0;
-  //   prev->setNext(this);
-  //   this->preve = pref;
-  // }
-  //
-  // ClientInformation::ClientInformation(ClientInformation *prev, ClientInformation *next){
-  //   this->nexte = next;
-  //   this->preve = prev;
-  //   this->preve->setNext(this);
-  //   this->nexte->setPrev(this);
-  // }
-
   ClientInformation::~ClientInformation() {
+    if(this==head_)
+      head_=next();
     if(prev()!=0)
       prev()->setNext(this->next());
@@ -103,8 +81,7 @@
 
   bool ClientInformation::setPrev(ClientInformation *prev) {
-    if(!head_)
-      this->preve = prev;
-    else
-      return false;
+    if(this==head_)
+      head_=prev;
+    this->preve = prev;
     return true;
   }
@@ -146,5 +123,5 @@
   }
 
-  bool ClientInformation::setGameStateID(int id){
+  bool ClientInformation::setGamestateID(int id){
     if(!this)
       return false;
@@ -172,12 +149,4 @@
     else
       return NULL;
-  }
-  
-  bool ClientInformation::getHead(){
-    return head_;
-  }
-  
-  void ClientInformation::setHead(bool h){
-    head_=h;
   }
   
@@ -215,7 +184,8 @@
 
   ClientInformation *ClientInformation::insertBack(ClientInformation *ins) {
-    if(!this)
-      return NULL;
-    ClientInformation *temp = this;
+    ClientInformation *temp = head_;
+    if(temp==head_){
+      return head_;
+    }
     while(temp->next()!=0){
       temp = temp->next();
@@ -227,7 +197,7 @@
 
   bool ClientInformation::removeClient(int clientID) {
-    if(!this || clientID==CLIENTID_UNKNOWN)
-      return false;
-    ClientInformation *temp = this;
+    if(clientID==CLIENTID_UNKNOWN)
+      return false;
+    ClientInformation *temp = head_;
     while(temp!=0 && temp->getID()!=clientID)
       temp = temp->next();
@@ -239,11 +209,10 @@
 
   bool ClientInformation::removeClient(ENetPeer *peer) {
-    if(!this || !peer)
-      return false;
-    ClientInformation *temp = this;
+    if(!peer)
+      return false;
+    ClientInformation *temp = head_;
     while(temp!=0){
-      if(!temp->head_)
-        if(temp->getPeer()->address.host==peer->address.host && temp->getPeer()->address.port==peer->address.port)
-          break;
+      if(temp->getPeer()->address.host==peer->address.host && temp->getPeer()->address.port==peer->address.port)
+        break;
       temp = temp->next();
     }
@@ -261,7 +230,5 @@
   */
   ClientInformation *ClientInformation::findClient(int clientID, bool look_backwards) {
-    ClientInformation *temp = this;
-    if (temp->head_)
-      temp=temp->next();
+    ClientInformation *temp = head_;
     while(temp!=0 && temp->getID()!=clientID){
       temp = temp->next();
@@ -278,10 +245,6 @@
   */
   ClientInformation *ClientInformation::findClient(ENetAddress *address, bool look_backwards) {
-    ClientInformation *temp = this;
+    ClientInformation *temp = head_;
     while(temp!=0){
-      if(temp->head_){
-        temp = temp->next();
-        continue;
-      }
       if(temp->getPeer()->address.host==address->host && temp->getPeer()->address.port == address->port)
         break;
Index: code/trunk/src/network/ClientInformation.h
===================================================================
--- code/trunk/src/network/ClientInformation.h	(revision 1639)
+++ code/trunk/src/network/ClientInformation.h	(revision 1735)
@@ -60,5 +60,4 @@
   public:
     ClientInformation();
-    ClientInformation(bool head);
     //   ClientInformation(ClientInformation *prev, ClientInformation *next);
     //   ClientInformation(ClientInformation *prev);
@@ -66,21 +65,19 @@
     ClientInformation *next();
     ClientInformation *prev();
-    ClientInformation *insertBack(ClientInformation *ins);
+    static ClientInformation *insertBack(ClientInformation *ins);
     
     // set functions
     void setID(int clientID);
     bool setPeer(ENetPeer *peer);
-    bool setGameStateID(int id);
+    bool setGamestateID(int id);
     bool setPartialGamestateID(int id);
-    inline void setShipID(int id){ShipID_=id;}
+    inline void setShipID(unsigned int id){ShipID_=id;}
     
     // get functions
-    inline int getShipID(){return ShipID_;}
+    inline unsigned int getShipID(){return ShipID_;}
     int getID();
     int getGamestateID();
     int getPartialGamestateID();
     ENetPeer *getPeer();
-    bool getHead();
-    void setHead(bool h);
     
     int getFailures();
@@ -90,10 +87,9 @@
     enet_uint32 getPacketLoss();
     
-    bool removeClient(int clientID);
-    bool removeClient(ENetPeer *peer);
-    //## add bool mask-function eventually
-    ClientInformation *findClient(int clientID, bool look_backwards=false);
-    //## add bool mask-function eventually
-    ClientInformation *findClient(ENetAddress *address, bool look_backwards=false);
+    static bool removeClient(int clientID);
+    static bool removeClient(ENetPeer *peer);
+    static ClientInformation *findClient(int clientID, bool look_backwards=false);
+    static ClientInformation *findClient(ENetAddress *address, bool look_backwards=false);
+    static ClientInformation *getBegin(){return head_;}
 
     bool setSynched(bool s);
@@ -101,7 +97,9 @@
 
 
-    private:
-      bool setNext(ClientInformation *next);
-      bool setPrev(ClientInformation *prev);
+  private:
+    static ClientInformation *head_;
+    
+    bool setNext(ClientInformation *next);
+    bool setPrev(ClientInformation *prev);
     ClientInformation *insertAfter(ClientInformation *ins);
     ClientInformation *insertBefore(ClientInformation *ins);
@@ -114,7 +112,6 @@
     int gamestateID_;
     int partialGamestateID_;
-    int ShipID_;   // this is the unique objectID
+    unsigned int ShipID_;   // this is the unique objectID
     bool synched_;
-    bool head_;
     unsigned short failures_;
     
Index: code/trunk/src/network/ConnectionManager.cc
===================================================================
--- code/trunk/src/network/ConnectionManager.cc	(revision 1639)
+++ code/trunk/src/network/ConnectionManager.cc	(revision 1735)
@@ -39,4 +39,5 @@
 
 #include <iostream>
+#include <assert.h>
 // boost.thread library for multithreading support
 #include <boost/bind.hpp>
@@ -50,4 +51,5 @@
 #include "ConnectionManager.h"
 #include "Synchronisable.h"
+#include "packet/ClassID.h"
 
 namespace std
@@ -65,33 +67,51 @@
   //boost::thread_group network_threads;
   
-  ConnectionManager::ConnectionManager():receiverThread_(0){}
-  boost::recursive_mutex ConnectionManager::enet_mutex_;
-  
-  ConnectionManager::ConnectionManager(ClientInformation *head) : receiverThread_(0) {
+  ConnectionManager *ConnectionManager::instance_=0;
+  
+  ConnectionManager::ConnectionManager():receiverThread_(0){
+    assert(instance_==0);
+    instance_=this;
     quit=false;
     bindAddress.host = ENET_HOST_ANY;
     bindAddress.port = NETWORK_PORT;
-    head_ = head;
-  }
-  
-  ConnectionManager::ConnectionManager(ClientInformation *head, int port){
+  }
+  boost::recursive_mutex ConnectionManager::enet_mutex;
+  
+//   ConnectionManager::ConnectionManager(ClientInformation *head) : receiverThread_(0) {
+//     assert(instance_==0);
+//     instance_=this;
+//     quit=false;
+//     bindAddress.host = ENET_HOST_ANY;
+//     bindAddress.port = NETWORK_PORT;
+//   }
+  
+  ConnectionManager::ConnectionManager(int port){
+    assert(instance_==0);
+    instance_=this;
     quit=false;
     bindAddress.host = ENET_HOST_ANY;
     bindAddress.port = port;
-    head_ = head;
-  }
-
-  ConnectionManager::ConnectionManager(int port, std::string address, ClientInformation *head) :receiverThread_(0) {
+  }
+
+  ConnectionManager::ConnectionManager(int port, std::string address) :receiverThread_(0) {
+    assert(instance_==0);
+    instance_=this;
     quit=false;
     enet_address_set_host (& bindAddress, address.c_str());
     bindAddress.port = NETWORK_PORT;
-    head_ = head;
-  }
-
-  ConnectionManager::ConnectionManager(int port, const char *address, ClientInformation *head) : receiverThread_(0) {
+  }
+
+  ConnectionManager::ConnectionManager(int port, const char *address) : receiverThread_(0) {
+    assert(instance_==0);
+    instance_=this;
     quit=false;
     enet_address_set_host (& bindAddress, address);
     bindAddress.port = NETWORK_PORT;
-    head_ = head;
+  }
+  
+  ConnectionManager::~ConnectionManager(){
+    instance_=0;
+    if(!quit)
+      quitListener();
   }
 
@@ -140,11 +160,19 @@
     return true;
   }
-
+  
+//   bool ConnectionManager::addPacket(Packet::Packet *packet){
+//     ClientInformation *temp = instance_->head_->findClient(packet->getClientID());
+//     if(!temp){
+//       COUT(3) << "C.Man: addPacket findClient failed" << std::endl;
+//       return false;
+//     }
+//     ENetPacket *packet = new ENetPacket;
+//     //  TODO: finish implementation
+//   }
+//   
+  
   bool ConnectionManager::addPacket(ENetPacket *packet, ENetPeer *peer) {
-    ClientInformation *temp = head_->findClient(&(peer->address));
-    if(!temp)
-      return false;
-    boost::recursive_mutex::scoped_lock lock(enet_mutex_);
-    if(enet_peer_send(peer, (enet_uint8)temp->getID() , packet)!=0)
+    boost::recursive_mutex::scoped_lock lock(instance_->enet_mutex);
+    if(enet_peer_send(peer, NETWORK_DEFAULT_CHANNEL, packet)!=0)
       return false;
     return true;
@@ -152,20 +180,17 @@
 
   bool ConnectionManager::addPacket(ENetPacket *packet, int clientID) {
-    ClientInformation *temp = head_->findClient(clientID);
+    ClientInformation *temp = ClientInformation::findClient(clientID);
     if(!temp){
       COUT(3) << "C.Man: addPacket findClient failed" << std::endl;
       return false;
     }
-    boost::recursive_mutex::scoped_lock lock(enet_mutex_);
-    if(enet_peer_send(temp->getPeer(), 0, packet)!=0){
-      COUT(3) << "C.Man: addPacket enet_peer_send failed" << std::endl;
-      return false;
-    }
-    return true;
+    return addPacket(packet, temp->getPeer());
   }
 
   bool ConnectionManager::addPacketAll(ENetPacket *packet) {
-    boost::recursive_mutex::scoped_lock lock(enet_mutex_);
-    for(ClientInformation *i=head_->next(); i!=0; i=i->next()){
+    if(!instance_)
+      return false;
+    boost::recursive_mutex::scoped_lock lock(instance_->enet_mutex);
+    for(ClientInformation *i=ClientInformation::getBegin()->next(); i!=0; i=i->next()){
       COUT(3) << "adding broadcast packet for client: " << i->getID() << std::endl;
       if(enet_peer_send(i->getPeer(), 0, packet)!=0)
@@ -177,7 +202,7 @@
   // we actually dont need that function, because host_service does that for us
   bool ConnectionManager::sendPackets() {
-    if(server==NULL)
-      return false;
-    boost::recursive_mutex::scoped_lock lock(enet_mutex_);
+    if(server==NULL || !instance_)
+      return false;
+    boost::recursive_mutex::scoped_lock lock(enet_mutex);
     enet_host_flush(server);
     lock.unlock();
@@ -190,5 +215,5 @@
     atexit(enet_deinitialize);
     { //scope of the mutex
-      boost::recursive_mutex::scoped_lock lock(enet_mutex_);
+      boost::recursive_mutex::scoped_lock lock(enet_mutex);
       enet_initialize();
       server = enet_host_create(&bindAddress, NETWORK_MAX_CONNECTIONS, 0, 0);
@@ -204,5 +229,5 @@
     while(!quit){
       { //mutex scope
-        boost::recursive_mutex::scoped_lock lock(enet_mutex_);
+        boost::recursive_mutex::scoped_lock lock(enet_mutex);
         if(enet_host_service(server, event, NETWORK_WAIT_TIMEOUT)<0){
           // we should never reach this point
@@ -246,5 +271,5 @@
     // if we're finishied, destroy server
     {
-      boost::recursive_mutex::scoped_lock lock(enet_mutex_);
+      boost::recursive_mutex::scoped_lock lock(enet_mutex);
       enet_host_destroy(server);
       lock.unlock();
@@ -257,8 +282,8 @@
   void ConnectionManager::disconnectClients() {
     ENetEvent event;
-    ClientInformation *temp = head_->next();
+    ClientInformation *temp = ClientInformation::getBegin()->next();
     while(temp!=0){
       {
-        boost::recursive_mutex::scoped_lock lock(enet_mutex_);
+        boost::recursive_mutex::scoped_lock lock(enet_mutex);
         enet_peer_disconnect(temp->getPeer(), 0);
         lock.unlock();
@@ -267,6 +292,6 @@
     }
     //bugfix: might be the reason why server crashes when clients disconnects
-    temp = head_->next();
-    boost::recursive_mutex::scoped_lock lock(enet_mutex_);
+    temp = ClientInformation::getBegin()->next();
+    boost::recursive_mutex::scoped_lock lock(enet_mutex);
     while( temp!=0 && enet_host_service(server, &event, NETWORK_WAIT_TIMEOUT) >= 0){
       switch (event.type)
@@ -279,6 +304,6 @@
       case ENET_EVENT_TYPE_DISCONNECT:
         COUT(4) << "disconnecting all clients" << std::endl;
-        if(head_->findClient(&(event.peer->address)))
-          delete head_->findClient(&(event.peer->address));
+        if(ClientInformation::findClient(&(event.peer->address)))
+          delete ClientInformation::findClient(&(event.peer->address));
         //maybe needs bugfix: might also be a reason for the server to crash
         temp = temp->next();
@@ -302,12 +327,16 @@
 
   int ConnectionManager::getClientID(ENetAddress address) {
-    return head_->findClient(&address)->getID();
+    return ClientInformation::findClient(&address)->getID();
   }
 
   ENetPeer *ConnectionManager::getClientPeer(int clientID) {
-    return head_->findClient(clientID)->getPeer();
-  }
-
-  void ConnectionManager::syncClassid(int clientID) {
+    return ClientInformation::findClient(clientID)->getPeer();
+  }
+
+  /**
+   * 
+   * @param clientID 
+   */
+  void ConnectionManager::syncClassid(unsigned int clientID) {
     unsigned int network_id=0, failures=0;
     std::string classname;
@@ -324,5 +353,7 @@
       COUT(4) << "Con.Man:syncClassid:\tnetwork_id: " << network_id << ", classname: " << classname << std::endl;
 
-      while(!addPacket(packet_gen.clid( (int)network_id, classname ), clientID) && failures < 10){
+      packet::ClassID *classid = new packet::ClassID( network_id, classname );
+      classid->setClientID(clientID);
+      while(!classid->send() && failures < 10){
         failures++;
       }
@@ -336,5 +367,5 @@
   
   bool ConnectionManager::removeShip(ClientInformation *client){
-    int id=client->getShipID();
+    unsigned int id=client->getShipID();
     orxonox::Iterator<orxonox::SpaceShip> it;
     for(it = orxonox::ObjectList<orxonox::SpaceShip>::start(); it; ++it){
@@ -346,15 +377,8 @@
   }
   
-  bool ConnectionManager::sendWelcome(int clientID, int shipID, bool allowed){
-    if(addPacket(packet_gen.generateWelcome(clientID, shipID, allowed),clientID)){
-      //sendPackets();
-      return true;
-    }else
-      return false;
-  }
   
   void ConnectionManager::disconnectClient(ClientInformation *client){
     {
-      boost::recursive_mutex::scoped_lock lock(enet_mutex_);
+      boost::recursive_mutex::scoped_lock lock(enet_mutex);
       enet_peer_disconnect(client->getPeer(), 0);
       lock.unlock();
@@ -363,12 +387,4 @@
   }
   
-  bool ConnectionManager::addFakeConnectRequest(ENetEvent *ev){
-    ENetEvent event;
-    event.peer=ev->peer;
-    event.packet = packet_gen.generateConnectRequest();
-    return buffer.push(&event);
-  }
-  
-  
 
 }
Index: code/trunk/src/network/ConnectionManager.h
===================================================================
--- code/trunk/src/network/ConnectionManager.h	(revision 1639)
+++ code/trunk/src/network/ConnectionManager.h	(revision 1735)
@@ -51,5 +51,5 @@
 
 #include "PacketBuffer.h"
-#include "PacketManager.h"
+#include "packet/Packet.h"
 
 namespace std
@@ -63,4 +63,5 @@
 #define NETWORK_MAX_CONNECTIONS 50
 #define NETWORK_WAIT_TIMEOUT 1
+#define NETWORK_DEFAULT_CHANNEL 0
 
   struct ClientList{
@@ -71,10 +72,12 @@
 
   class ConnectionManager{
-  public:
+    public:
+    static boost::recursive_mutex enet_mutex;
     ConnectionManager();
-    ConnectionManager(ClientInformation *head);
-    ConnectionManager(ClientInformation *head, int port);
-    ConnectionManager(int port, const char *address, ClientInformation *head);
-    ConnectionManager(int port, std::string address, ClientInformation *head);
+    //ConnectionManager(ClientInformation *head);
+    ConnectionManager(int port);
+    ConnectionManager(int port, const char *address);
+    ConnectionManager(int port, std::string address);
+    ~ConnectionManager();
     //ENetPacket *getPacket(ENetAddress &address); // thread1
     //ENetPacket *getPacket(int &clientID);
@@ -83,13 +86,13 @@
     void createListener();
     bool quitListener();
-    bool addPacket(ENetPacket *packet, ENetPeer *peer);
-    bool addPacket(ENetPacket *packet, int ID);
-    bool addPacketAll(ENetPacket *packet);
+//     bool addPacket(Packet::Packet *packet);
+    static bool addPacket(ENetPacket *packet, ENetPeer *peer);
+    static bool addPacket(ENetPacket *packet, int ID);
+    static bool addPacketAll(ENetPacket *packet);
   //  bool sendPackets(ENetEvent *event);
     bool sendPackets();
     //bool createClient(int clientID);
     void disconnectClient(ClientInformation *client);
-    void syncClassid(int clientID);
-    bool sendWelcome(int clientID, int shipID, bool allowed);
+    void syncClassid(unsigned int clientID);
 
   private:
@@ -105,7 +108,5 @@
     //bool createShip(ClientInformation *client);
     bool removeShip(ClientInformation *client);
-    bool addFakeConnectRequest(ENetEvent *ev);
     PacketBuffer buffer;
-    PacketGenerator packet_gen;
 
     ENetHost *server;
@@ -113,16 +114,8 @@
 
     bool quit; // quit-variable (communication with threads)
-    ClientInformation *head_;
 
     boost::thread *receiverThread_;
-    static boost::recursive_mutex enet_mutex_;
-//     int getNumberOfClients();
-    //functions to map what object every clients uses
-    /*std::map<int, int> clientsShip;
-    void addClientsObjectID( int clientID, int objectID );
-    int getClientsShipID( int clientID );
-    int getObjectsClientID( int objectID );
-    void deleteClientIDReg( int clientID );
-    void deleteObjectIDReg( int objectID );*/
+    static ConnectionManager *instance_;
+
   };
 
